#ifndef STACK_H_
#define STACK_H_

#include <stdlib.h>
#include <stdint.h>

/*
 * 2 Stive intr-una implementata cu vectori.
 * Unul pentru 'stiva' operanzilor si cealalta pentru stiva operatorilor.
 * Fiecare din cele 2 stive are operatiile proprii.
 */

#define CAPACITY 16

typedef struct stack {
    double operand_arr[CAPACITY];
    char operator_arr[CAPACITY];
    uint8_t operand_arr_size;
    uint8_t operator_arr_size;
} stack;

void stack_push_operand(stack *s, double operand)
{
    if (s->operand_arr_size >= CAPACITY) {
        // eroare
        return ;
    }

    s->operand_arr[s->operand_arr_size++] = operand;
}

void stack_push_operator(stack *s, char op)
{
    if (s->operator_arr_size >= CAPACITY) {
        // eroare
        return ;
    }

    s->operator_arr[s->operator_arr_size++] = op;
}

double stack_peek_operand(stack *s)
{
    return s->operand_arr[s->operand_arr_size - 1];
}

char stack_peek_operator(stack *s)
{
    return s->operator_arr[s->operator_arr_size - 1];
}

double stack_pop_operand(stack *s)
{
    double operand = s->operand_arr[s->operand_arr_size - 1];
    s->operand_arr[s->operand_arr_size--] = 0;
    return operand;
}

char stack_pop_operator(stack *s)
{
    double op = s->operator_arr[s->operator_arr_size - 1];
    s->operator_arr[s->operator_arr_size--] = 0;
    return op;
}

uint8_t stack_size_operand(stack *s)
{
    return s->operand_arr_size;
}

uint8_t stack_size_operator(stack *s)
{
    return s->operator_arr_size;
}

#endif /* STACK_H_ */
